/* --------------------------------------------------------------------//
//     ColCus   version 1.00                                           //
//                                                                     //
//                     Absurd Technology Lab                           //
//              website: http://www5b.biglobe.ne.jp/~hokko2nd/         //
//               e-mail: atl_soft@yahoo.com                            //
//---------------------------------------------------------------------*/

//#define UNICODE

#if defined(_MSC_VER) && defined(_DEBUG)
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#define MEMLEAK_OUTPUT() _CrtDumpMemoryLeaks()
#else
#define MEMLEAK_OUTPUT()
#endif

#define WINVER 0x0400
#define _WIN32_IE 0x200

#include <windows.h>
#include <commctrl.h>
#include "resource.h"

#pragma comment(lib, "comctl32.lib")
#pragma comment(linker, "/opt:nowin98")

typedef struct tagCOLORELEMENT {
	TCHAR	*elementName;
	INT		elementNumber;
	INT		os;
} COLORELEMENT, * FAR LPCOLORELEMENT;

#define WIN95 40000
#define WIN98 40010
#define WINMe 40090
#define WIN2k 50000
#define WINXP 50001

#define _WM_SETORGPROC	(WM_APP + 100)

LRESULT CALLBACK MainDlgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
LRESULT CALLBACK NameListProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
BOOL InitNameList( HWND hNameList );
BOOL LoadColorData( HWND hNameList );
BOOL SetAndSaveColors( HWND hNameList );
BOOL SetColor( HWND hParent, LPCOLORREF lpColor );

inline COLORREF	Str2Colorref( LPTSTR lpszText )
{
	BYTE	bRGB[3] = { 0, 0, 0 };
	int		nCurCol = 0;

	
	for( ; *lpszText; lpszText++ )
	{
		if( *lpszText == ' ' )
			nCurCol++;
		else
		{
			bRGB[nCurCol] = bRGB[nCurCol]*10 + ( *lpszText - '0' );
		}
	}

	return RGB( bRGB[0], bRGB[1], bRGB[2] );
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
	InitCommonControls();
	DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_MAIN ), NULL, (DLGPROC)MainDlgProc, NULL );

	MEMLEAK_OUTPUT();
	return 0;
}

LRESULT CALLBACK MainDlgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static HWND			hNameList;
	static HINSTANCE	hInst;
	static HMENU		hNameListContext;
	static UINT			uFormat;

	INT		nIndex;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		uFormat = RegisterClipboardFormat( TEXT("COLORREF") );
		if( !uFormat )
		{
			EndDialog( hWnd, 0 );
			break;
		}
		hInst = (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE );
		SendMessage( hWnd, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon( hInst, MAKEINTRESOURCE(IDI_MAIN) ) );
		SendMessage( hWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadImage(hInst, MAKEINTRESOURCE(IDI_MAIN), IMAGE_ICON, GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR) );
		hNameListContext = GetSubMenu( LoadMenu( hInst, MAKEINTRESOURCE(IDR_POPUP) ), 0 );
		hNameList = GetDlgItem( hWnd, IDC_NAMELIST );
		NameListProc( hNameList, _WM_SETORGPROC, GetWindowLong( hNameList, GWL_WNDPROC ), 0 );
		SetWindowLong( hNameList, GWL_WNDPROC, (LONG)NameListProc );
		InitNameList( hNameList );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			SetAndSaveColors( hNameList );
			EndDialog( hWnd, 1 );
			break;
		case IDCANCEL:
			EndDialog( hWnd, 0 );
			break;
		case IDAPPLY:
			SetAndSaveColors( hNameList );
			EnableWindow( GetDlgItem( hWnd, IDAPPLY ), FALSE );
			break;
		case IDC_RELOAD:
			LoadColorData( hNameList );
			break;

		case IDM_COPY:
			nIndex = ListView_GetNextItem( hNameList, -1, LVNI_SELECTED );
			if( nIndex != -1 )
			{
				TCHAR	szValue[32];
				LPCOLORREF	lpcol;

				if( !( lpcol = (LPCOLORREF)GlobalAlloc( GMEM_FIXED, sizeof(COLORREF) ) ) )
					break;

				ListView_GetItemText( hNameList, nIndex, 1, szValue, 32 );
				*lpcol = Str2Colorref( szValue );

				if( !OpenClipboard( hWnd ) )
				{
					GlobalFree( lpcol );
					break;
				}
				EmptyClipboard();
				SetClipboardData( uFormat, lpcol );
				CloseClipboard();
			}
			break;

		case IDM_PASTE:
			nIndex = ListView_GetNextItem( hNameList, -1, LVNI_SELECTED );
			if( nIndex != -1 && IsClipboardFormatAvailable( uFormat ) )
			{
				TCHAR	szValue[32];
				LPCOLORREF	lpcol;
				COLORREF	col;

				if( !OpenClipboard( hWnd ) )
					break;
				lpcol = (LPCOLORREF)GetClipboardData( uFormat );
				if( lpcol )
					col = *lpcol;
				CloseClipboard();

				wsprintf( szValue, TEXT("%d %d %d"), GetRValue(col), GetGValue(col), GetBValue(col) );
				ListView_SetItemText( hNameList, nIndex, 1, szValue );
				EnableWindow( GetDlgItem( hWnd, IDAPPLY ), TRUE );
			}
			break;
		}
		break;

	case WM_NOTIFY:
		if( wParam != IDC_NAMELIST )
			break;
		if( ( (LPNMHDR)lParam )->code == NM_DBLCLK )
		{
			INT			nIndex;
			TCHAR		szValue[32];
			COLORREF	col;

			nIndex = ListView_GetNextItem( hNameList, -1, LVNI_SELECTED );
			if( nIndex != -1 )
			{
				ListView_GetItemText( hNameList, nIndex, 1, szValue, 32 );
				col = Str2Colorref( szValue );
				if( SetColor( hWnd, &col ) )
				{
					wsprintf( szValue, TEXT("%d %d %d"), GetRValue(col), GetGValue(col), GetBValue(col) );
					ListView_SetItemText( hNameList, nIndex, 1, szValue );
					EnableWindow( GetDlgItem( hWnd, IDAPPLY ), TRUE );
				}
			}
		}
		break;

	case WM_CONTEXTMENU:
		if( (HWND)wParam == hNameList )
		{
			MENUITEMINFO	mii;

			mii.cbSize = sizeof(mii);
			mii.fMask = MIIM_STATE;
			if( ListView_GetNextItem( hNameList, -1, LVNI_SELECTED ) != -1 )
			{
				mii.fState = MFS_ENABLED;
				SetMenuItemInfo( hNameListContext, IDM_COPY, FALSE, &mii);
				if( IsClipboardFormatAvailable( uFormat ) )
					mii.fState = MFS_ENABLED;
				else
					mii.fState = MFS_DISABLED;
				SetMenuItemInfo( hNameListContext, IDM_PASTE, FALSE, &mii);
			}
			else
			{
				mii.fState = MFS_DISABLED;
				SetMenuItemInfo( hNameListContext, IDM_COPY, FALSE, &mii);
				SetMenuItemInfo( hNameListContext, IDM_PASTE, FALSE, &mii);
			}
			TrackPopupMenuEx( hNameListContext, 0, LOWORD(lParam), HIWORD(lParam), hWnd, NULL );
			PostMessage( hWnd, WM_NULL, 0, 0 );
		}
		break;

	case WM_DESTROY:
		DestroyMenu( hNameListContext );
		break;
	}
	return FALSE;
}

BOOL InitNameList( HWND hNameList )
{
	LVCOLUMN		lvCol;
	RECT			rc;
	TCHAR			szText[32];
	HINSTANCE		hInst;


//	ListView_SetExtendedListViewStyle(hList, LVS_EX_FULLROWSELECT|LVS_EX_FLATSB);
	SendMessage( hNameList, LVM_FIRST + 54, 0, 0x00000120 );

	hInst = (HINSTANCE)GetWindowLong( hNameList, GWL_HINSTANCE );
	GetClientRect( hNameList, &rc );
	lvCol.mask = LVCF_TEXT | LVCF_WIDTH;
	lvCol.pszText  = szText;
	lvCol.cx = ( rc.right - GetSystemMetrics( SM_CXVSCROLL ) )/2;
	LoadString( hInst, IDS_COLUMN_NAME, szText, 32 );
	ListView_InsertColumn( hNameList, 0, &lvCol );
	LoadString( hInst, IDS_COLUMN_VALUE, szText, 32 );
	ListView_InsertColumn( hNameList, 1, &lvCol );

	return LoadColorData( hNameList );
}

LRESULT CALLBACK NameListProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static WNDPROC	OrgProc;

	switch( uMsg )
	{
	case _WM_SETORGPROC:
		OrgProc = (WNDPROC)wParam;
		return 0;

	case WM_CHAR:
		switch( wParam )
		{
		case 3:/* Ctrl + C */
			SendMessage( GetParent( hWnd ), WM_COMMAND, IDM_COPY, 0 );
			break;
		case 22:/* Ctrl + V */
			SendMessage( GetParent( hWnd ), WM_COMMAND, IDM_PASTE, 0 );
			break;
		}
		break;
	}
	return CallWindowProc( OrgProc, hWnd, uMsg, wParam, lParam );
}

BOOL LoadColorData( HWND hNameList )
{
	LPCOLORELEMENT	lpCE;
	OSVERSIONINFO	osvi;
	LVITEM			lvItem;
	HKEY			hKey;
	DWORD			dwSize;
	INT				nVersion;
	TCHAR			szText[32];

	COLORELEMENT Elements[] = {
		{ TEXT("ActiveBorder"),			COLOR_ACTIVEBORDER,					WIN95 },
		{ TEXT("ActiveTitle"),			COLOR_ACTIVECAPTION,				WIN95 },
		{ TEXT("AppWorkSpace"),			COLOR_APPWORKSPACE,					WIN95 },
		{ TEXT("Background"),			COLOR_BACKGROUND,					WIN95 },
		{ TEXT("ButtonAlternateFace"),	25/*[no identifier]*/,				WIN95 },
		{ TEXT("ButtonDkShadow"),		COLOR_3DDKSHADOW,					WIN95 },
		{ TEXT("ButtonFace"),			COLOR_3DFACE,						WIN95 },
		{ TEXT("ButtonHilight"),		COLOR_3DHIGHLIGHT,					WIN95 },
		{ TEXT("ButtonLight"),			COLOR_3DLIGHT,						WIN95 },
		{ TEXT("ButtonShadow"),			COLOR_3DSHADOW,						WIN95 },
		{ TEXT("ButtonText"),			COLOR_BTNTEXT,						WIN95 },
		{ TEXT("GradientActiveTitle"),	27/*COLOR_GRADIENTACTIVECAPTION*/,	WIN98 },
		{ TEXT("GradientInactiveTitle"),28/*COLOR_GRADIENTINACTIVECAPTION*/,WIN98 },
		{ TEXT("GrayText"),				COLOR_GRAYTEXT,						WIN95 },
		{ TEXT("Hilight"),				COLOR_HIGHLIGHT,					WIN95 },
		{ TEXT("HilightText"),			COLOR_HIGHLIGHTTEXT,				WIN95 },
		{ TEXT("HotTrackingColor"),		26/*COLOR_HOTLIGHT*/,				WIN98 },
		{ TEXT("InactiveBorder"),		COLOR_INACTIVEBORDER,				WIN95 },
		{ TEXT("InactiveTitle"),		COLOR_INACTIVECAPTION,				WIN95 },
		{ TEXT("InactiveTitleText"),	COLOR_INACTIVECAPTIONTEXT,			WIN95 },
		{ TEXT("InfoText"),				COLOR_INFOTEXT,						WIN95 },
		{ TEXT("InfoWindow"),			COLOR_INFOBK,						WIN95 },
		{ TEXT("Menu"),					COLOR_MENU,							WIN95 },
		{ TEXT("MenuHilight"),			29/*COLOR_MENUHILIGHT*/,			WINXP },
		{ TEXT("MenuBar"),				30/*COLOR_MENUBAR*/,				WINXP },
		{ TEXT("MenuText"),				COLOR_MENUTEXT,						WIN95 },
		{ TEXT("Scrollbar"),			COLOR_SCROLLBAR,					WIN95 },
		{ TEXT("TitleText"),			COLOR_CAPTIONTEXT,					WIN95 },
		{ TEXT("Window"),				COLOR_WINDOW,						WIN95 },
		{ TEXT("WindowFrame"),			COLOR_WINDOWFRAME,					WIN95 },
		{ TEXT("WindowText"),			COLOR_WINDOWTEXT,					WIN95 },
		{ TEXT(""), 0, 0 }
	};

	ListView_DeleteAllItems( hNameList );
	osvi.dwOSVersionInfoSize = sizeof(osvi);
	GetVersionEx( &osvi );
	nVersion = osvi.dwMajorVersion * 10000 + osvi.dwMinorVersion;

	if( RegOpenKeyEx( HKEY_CURRENT_USER, TEXT("Control Panel\\Colors"), 0, KEY_READ, &hKey ) != ERROR_SUCCESS )
		return FALSE;

	for( lpCE = Elements; *lpCE->elementName; lpCE++ )
	{
		if( nVersion < lpCE->os )
			continue;
		lvItem.mask		= LVIF_TEXT | LVIF_PARAM;
		lvItem.iItem	= 0;
		lvItem.iSubItem	= 0;
		lvItem.pszText	= lpCE->elementName;
		lvItem.lParam	= lpCE->elementNumber;
		lvItem.iItem	= ListView_InsertItem( hNameList, &lvItem );
		lvItem.mask		= LVIF_TEXT;
		lvItem.iSubItem	= 1;
		lvItem.pszText	= szText;
		dwSize = sizeof(szText);
		if( RegQueryValueEx( hKey, lpCE->elementName, NULL, NULL, (LPBYTE)szText, &dwSize ) != ERROR_SUCCESS )
			szText[0] = '\0';
		ListView_SetItem( hNameList, &lvItem );
	}
	RegCloseKey( hKey );

	return TRUE;
}

BOOL SetAndSaveColors( HWND hNameList )
{
	HKEY		hKey;
	INT			i, nItemCount;
	LVITEM		lvItem;
	TCHAR		szName[32];
	TCHAR		szValue[32];
	COLORREF	*lpaRgbValues = 0;
	INT			*lpaElements = 0;

	if( RegOpenKeyEx( HKEY_CURRENT_USER, TEXT("Control Panel\\Colors"), 0, KEY_WRITE, &hKey ) != ERROR_SUCCESS )
		return FALSE;

	nItemCount = ListView_GetItemCount( hNameList );


	try
	{
		if( !( lpaRgbValues = new COLORREF[nItemCount] ) )
			throw 0;
		if( !( lpaElements = new INT[nItemCount] ) )
			throw 0;

		for( i = 0; i < nItemCount; i++ )
		{
			lvItem.mask			= LVIF_TEXT;
			lvItem.iItem		= i;
			lvItem.iSubItem		= 1;
			lvItem.pszText		= szValue;
			lvItem.cchTextMax	= 32;
			ListView_GetItem( hNameList, &lvItem );

			lvItem.mask			= LVIF_TEXT | LVIF_PARAM;
			lvItem.iSubItem		= 0;
			lvItem.pszText		= szName;
			lvItem.cchTextMax	= 32;
			ListView_GetItem( hNameList, &lvItem );

			if( szValue[0] )
			{
				if( RegSetValueEx( hKey, szName, NULL, REG_SZ, (LPBYTE)szValue, ( lstrlen(szValue) +1 )*sizeof(TCHAR) ) != ERROR_SUCCESS )
					throw 0;
			}

			lpaElements[i] = lvItem.lParam;
			lpaRgbValues[i] = Str2Colorref( szValue );
		}
		RegCloseKey( hKey );

		SetSysColors( nItemCount, lpaElements, lpaRgbValues );
	}
	catch(...)
	{
		if( lpaRgbValues )
			delete[] lpaRgbValues;
		if( lpaElements )
			delete[] lpaElements;
		return FALSE;
	}

	delete[] lpaRgbValues;
	delete[] lpaElements;

	return TRUE;
}

BOOL SetColor( HWND hParent, LPCOLORREF lpColor )
{
	static	BOOL			fAl;
	static	DWORD			dwCustColors[16];
	static	CHOOSECOLOR		cc;

	if( !fAl )
	{
		ZeroMemory( &cc, sizeof(CHOOSECOLOR) );
		for( int i = 0; i < 16; i++ )
		{
			dwCustColors[i] = 0x00ffffff;
		}
		cc.lStructSize = sizeof(CHOOSECOLOR);
		cc.lpCustColors = dwCustColors;
		cc.Flags = CC_RGBINIT| CC_FULLOPEN;
		fAl = TRUE;
	}

	cc.hwndOwner = hParent;
	cc.rgbResult = *lpColor;
	if( ChooseColor( &cc ) )
	{
		*lpColor = cc.rgbResult;
		return TRUE;
	}
	return FALSE;
}
